#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Drawing;
using System.Windows.Forms;

namespace HeuristicLab.Visualization {
  public interface IPrimitive {
    Pen Pen { get; set; }
    Brush Brush { get; set; }
    bool Selected { get; set; }
    string ToolTipText { get; set; }
    object Tag { get; set; }

    void Move(Offset delta);
    void Move(PointD point, Offset delta);

    void SnapToGrid(IGrid grid);
    void SnapToGrid(PointD point, IGrid grid);

    bool ContainsPoint(PointD point);
    Cursor GetCursor(PointD point);
    string GetToolTipText(PointD point);

    void PreDraw(Graphics graphics);
    void Draw(Graphics graphics);
    void PostDraw(Graphics graphics);

    event EventHandler RedrawRequired;
  }
}
